﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace NCC
{
    public partial class ProbeForm : Form
    {
        public double offset;
        public static double dia = 0;
        public Form1 ParentForm1;

        private string msg;

        public ProbeForm()
        {
            InitializeComponent();
            timer1.Enabled = false;
        }

        private void StartButton_Click(object sender, EventArgs e)
        {
            try
            {
                msg = "オフセットを正しく入力してください";
                offset = System.Convert.ToDouble(offsetTextBox.Text);
                msg = "工具径を正しく入力してください";
                dia = System.Convert.ToDouble(diaTextBox.Text);
                if (dia <= 0)
                {
                    MessageBox.Show(msg, "エラー", MessageBoxButtons.OK);
                    return;
                }
                string cmd;
                string axis = (string)Tag;
                if (axis == "X")
                    cmd = "G91G38.2 X-10 F10";
                else
                    cmd = "G91G38.2 Y-10 F10";
                ParentForm1.sendCommand(cmd);
                timer1.Enabled = true;
                StartButton.Enabled = false;
                cancelButton.Enabled = false;
                offsetTextBox.Enabled = false;
                diaTextBox.Enabled = false;
            }
            catch
            {
                MessageBox.Show(msg, "エラー", MessageBoxButtons.OK);
                return;
            }
        }

        private void cancelButton_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void ProbeForm_Shown(object sender, EventArgs e)
        {
            if ((string)Tag == "X")
                offset = 40.0;
            else
                offset = 30.0;
            Text = (string)Tag + "プローブ検出";
            offsetTextBox.Text = offset.ToString("F2");
            diaTextBox.Text = dia.ToString("F2");
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            string state = ParentForm1.GetState();
            if (state == "Idle")
            {
                timer1.Enabled = false;
                ParentForm1.sendCommand("G90");   // 絶対値指定
                // オフセット位置設定
                double ofs = offset + dia / 2;
                string cmd = "G90G10L20P0" + (string)Tag + ofs.ToString("F2");
                ParentForm1.sendCommand(cmd);
                if ((string)Tag == "X")
                    ParentForm1.xCur = ofs;
                if ((string)Tag == "Y")
                    ParentForm1.yCur = ofs;

                System.Threading.Thread.Sleep(100); // CNCシールドが準備完了になるまで待つ

                cmd = "G01" + (string)Tag + (ofs + 2.0).ToString("F2") + "F100"; // 検出位置から2mmずらす
                ParentForm1.sendCommand(cmd);
                StartButton.Enabled = true;
                cancelButton.Enabled = true;
                offsetTextBox.Enabled = true;
                diaTextBox.Enabled = true;
                Close();
            }
            if (state == "Alarm")
            {
                timer1.Enabled = false;
                ParentForm1.sendCommand("$X");
                ParentForm1.sendCommand("G90");   // 絶対値指定
                StartButton.Enabled = true;
                cancelButton.Enabled = true;
                offsetTextBox.Enabled = true;
                diaTextBox.Enabled = true;
                MessageBox.Show("プローブが検出できませんでした", "エラー", MessageBoxButtons.OK);
            }
        }

        private void stopButton_Click(object sender, EventArgs e)
        {
            ParentForm1.reset();
            StartButton.Enabled = true;
            cancelButton.Enabled = true;
            offsetTextBox.Enabled = true;
            diaTextBox.Enabled = true;
        }
    }
}
