﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO.Ports;
using System.Text.RegularExpressions;

// C:\Program Files (x86)\Reference Assemblies\Microsoft\Framework\.NETFramework\v4.6\Profile\Client の PresentationCore.dll を追加 (System.Windows.Input.Keybord)
// C:\Program Files (x86)\Reference Assemblies\Microsoft\Framework\.NETFramework\v4.6\Profile\Client の WindowsBase.dll を追加 (System.Windows.Input.Key)

namespace NCC
{
    public partial class Form1 : Form
    {
        public double xCur, yCur;

        private
        double xMPOS, yMPOS, zMPOS; // 機械座標
        double xWCO, yWCO, zWCO;    // オフセット
        double x1, y1;              // 始点
        double x2, y2;              // 中心点
        double zUP;                 // Zアップ位置
        double F;                   // 送りF
        double xBacklash, yBacklash;// バックラッシ
        bool xPlus, yPlus;          // 正方向(0含む)に動いていればtrue
        double xOfs, yOfs;

        bool playing;               // 再生中
        bool pausing;				// 一時停止中
        bool axisInitialized;
        string[] commands;
        IniFile ini;
        Regex jogR, jogA, line, cw, ccw;
        Regex valX, valY, valI, valJ, valF;
        Regex resetV;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            xMPOS = yMPOS = zMPOS = 0;
            xWCO = yWCO = zWCO = 0;
            zUP = 0;
            F = 100;
            playing = false;
            pausing = false;

            ini = new IniFile(".\\NCC.ini");
            string v = ini.getValueString("System", "Port");
            string[] ports = SerialPort.GetPortNames();
            foreach (string port in ports)
            {
                portComboBox.Items.Add(port);
            }
            int n = portComboBox.Items.IndexOf(v);
            if (n < 0 && portComboBox.Items.Count > 0)
                n = 0;
            portComboBox.SelectedIndex = n;

            v = ini.getValueString("System", "XBacklash");
            try
            {
                xBacklash = System.Convert.ToDouble(v);
            }
            catch
            {
                xBacklash = 0;
            }
            v = ini.getValueString("System", "YBacklash");
            try
            {
                yBacklash = System.Convert.ToDouble(v);
            }
            catch
            {
                yBacklash = 0;
            }

            motorOffButton.Enabled = false;
            tabControl1.SelectedIndex = 1;

            jogR = new Regex(@"^\$J=G91", RegexOptions.IgnoreCase | RegexOptions.Singleline);
            jogA = new Regex(@"^\$J=G90", RegexOptions.IgnoreCase | RegexOptions.Singleline);
            line = new Regex(@"^G01\D", RegexOptions.IgnoreCase | RegexOptions.Singleline);
            cw = new Regex(@"^G02\D", RegexOptions.IgnoreCase | RegexOptions.Singleline);
            ccw = new Regex(@"^G03\D", RegexOptions.IgnoreCase | RegexOptions.Singleline);
            valX = new Regex(@"X(?<V>-?\d+(\.\d*)?)", RegexOptions.IgnoreCase | RegexOptions.Singleline);
            valY = new Regex(@"Y(?<V>-?\d+(\.\d*)?)", RegexOptions.IgnoreCase | RegexOptions.Singleline);
            valI = new Regex(@"I(?<V>-?\d+(\.\d*)?)", RegexOptions.IgnoreCase | RegexOptions.Singleline);
            valJ = new Regex(@"J(?<V>-?\d+(\.\d*)?)", RegexOptions.IgnoreCase | RegexOptions.Singleline);
            valF = new Regex(@"F(?<V>-?\d+(\.\d*)?)", RegexOptions.IgnoreCase | RegexOptions.Singleline);
            resetV = new Regex(@"^Grbl (?<V>.+?)$", RegexOptions.IgnoreCase | RegexOptions.Singleline);
            xPlus = true;
            yPlus = true;
            xCur = yCur = 0;
            xOfs = 0;
            yOfs = 0;
            commands = new string[0];
            zUpTextBox.Text = zUP.ToString("F2");

        }
        public void reset()
        {
            axisInitialized = false;
            serialPort1.Write("\x18");          // reset
            logTextBox.AppendText(" reset\r\n");
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            SerialClose();
        }

        private void axzisClick(object sender, EventArgs e)
        {
            axisLabel.Text = (string)((TextBox)sender).Tag;
            axisPanel.Location = ((TextBox)sender).Parent.Location;
            axisTextBox.Text = ((TextBox)sender).Text;
            axisTextBox.SelectAll();
            axisPanel.Visible = true;
            axisTextBox.Focus();
        }

        private void zeroClick(object sender, EventArgs e)
        {
            string axis = (string)((Button)sender).Tag;
            if (serialPort1.IsOpen)
            {
                String str = String.Format("G90G10L20P0{0}0", axis);
                sendCommand(str);
                if (axis == "X")
                    this.xCur = 0;
                if (axis == "Y")
                    this.yCur = 0;
            }
        }

        private void jogClick(object sender, EventArgs e)
        {
            string axis = (string)((Button)sender).Tag;
            string text = ((Button)sender).Text;
            double v = 0;
            if (text == "<<<") v = -10.0;
            if (text == "<<") v = -1.0;
            if (text == "<") v = -0.1;
            if (text == ">>>") v = 10.0;
            if (text == ">>") v = 1.0;
            if (text == ">") v = 0.1;
            if (serialPort1.IsOpen)
            {
                String str = String.Format("$J=G91G21{0}{1}F{2}", axis, v, F);   // インクリメンタル・メトリック・直線補完
                sendCommand(str);
            }
        }

        private void feedClick(object sender, EventArgs e)
        {
            string text = ((Button)sender).Text;
            double v = 0;
            if (text == "<<<") v = -100;
            if (text == "<<") v = -10;
            if (text == "<") v = -1;
            if (text == ">>>") v = 100;
            if (text == ">>") v = 10;
            if (text == ">") v = 1;
            if (F + v < 1)
                F = 1;
            else if (F + v > 500)
                F = 500;
            else
                F += v;
            fTextBox.Text = F.ToString("F0");
        }

        private void axisSetButton_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen)
            {
                string axis = axisLabel.Text;
                double v;
                try
                {
                    v = System.Convert.ToDouble(axisTextBox.Text);
                    if (axis != "F")
                    {
                        String str = String.Format("$J=G90G20{0}{1}F{2}", axis, v, 100);
                        sendCommand(str);
                        axisPanel.Visible = false;
                    } else
                    {
                        if (v <= 0 || v > 400)
                            return;
                    }
                }
                catch { }
            }
        }

        private void axisCancelButton_Click(object sender, EventArgs e)
        {
            axisPanel.Visible = false;
        }

        private void zUpSetButton_Click(object sender, EventArgs e)
        {
            zUP = zMPOS;
            zUpTextBox.Text = (zUP - zWCO).ToString("N2");
        }

        private void zUpButton_Click(object sender, EventArgs e)
        {
            // Z軸工具アップ コマンド記録＆Z移動
            String str = String.Format("G0 Z{0}", zUP - zWCO);
            elementListBox.Items.Add(str);
            sendCommand(str);
        }

        private void zDownButton_Click(object sender, EventArgs e)
        {
            // Z軸工具ダウン コマンド記録
            String str = String.Format("G0 Z{0}", zMPOS - zWCO);
            elementListBox.Items.Add(str);
        }

        private void radioChanged(object sender, EventArgs e)
        {
            _radioChanged();
        }

        private void _radioChanged()
        {
            if (lineRadioButton.Checked)
            {
                startButton.Enabled = false;
                centerButton.Enabled = false;
                endButton.Enabled = true;
            }
            else
            {
                startButton.Enabled = true;
                centerButton.Enabled = false;
                endButton.Enabled = false;
            }
            startButton.Text = "始点";
            centerButton.Text = "中心";
            endButton.Text = "終点";
        }

        // 円弧の始点を指定
        private void startButton_Click(object sender, EventArgs e)
        {
            x1 = xMPOS;
            y1 = yMPOS;
            startButton.Text = String.Format("始点 ({0}, {1})", xMPOS - xWCO, yMPOS - yWCO);
            startButton.Enabled = false;
            centerButton.Enabled = true;
        }

        // 円弧の中心を指定
        private void centerButton_Click(object sender, EventArgs e)
        {
            x2 = xMPOS;
            y2 = yMPOS;
            centerButton.Text = String.Format("中心 ({0}, {1})", xMPOS - xWCO, yMPOS - yWCO);
            centerButton.Enabled = false;
            endButton.Enabled = true;
        }

        // 直線・円弧の終点を指定
        private void endButton_Click(object sender, EventArgs e)
        {
            if (lineRadioButton.Checked)
            {   // 直線移動
                String str;
                str = "G01 X" + (xMPOS - xWCO).ToString("F2") + " Y" + (yMPOS - yWCO).ToString("F2") +
                    " F" + F.ToString("F0");
                elementListBox.Items.Add(str);
            }
            if (arcCWRadioButton.Checked || arcCCWRadioButton.Checked)
            {   // CW円弧移動
                double x3 = xMPOS;
                double y3 = yMPOS;
                double r1 = Math.Sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
                double r3 = Math.Sqrt((x3 - x2) * (x3 - x2) + (y3 - y2) * (y3 - y2));
                if (Math.Abs(r1) < 0.01)
                {
                    MessageBox.Show("始点の半径が0です", "半径エラー", MessageBoxButtons.OK);
                    return;
                }
                if (Math.Abs(r3) < 0.01)
                {
                    MessageBox.Show("終点の半径が0です", "半径エラー", MessageBoxButtons.OK);
                    return;
                }
                if (Math.Abs(r1 - r3) >= 0.01)
                {
                    MessageBox.Show("始点・終点の半径が異なります", "半径エラー", MessageBoxButtons.OK);
                    return;
                }
                int dir = 2;
                if (arcCCWRadioButton.Checked)
                    dir = 3;
                String str;
                str = "G01 X" + (x1 - xWCO).ToString("F2") + " Y" + (y1 - yWCO).ToString("F2") +
                    " F" + F.ToString("F0");
                elementListBox.Items.Add(str);
                // F.ToString("N0");
                str = "G0" + dir.ToString("D") +
                    " X" + (xMPOS - xWCO).ToString("F2") + " Y" + (yMPOS - yWCO).ToString("F2") +
                    " I" + (x2 - x1).ToString("F2") + " J" + (y2 - y1).ToString("F2") +
                    " F" + F.ToString("F0");
                elementListBox.Items.Add(str);
            }
            _radioChanged();
        }

        private void clearButton_Click(object sender, EventArgs e)
        {
            elementListBox.Items.Clear();
        }

        private void deleteButton_Click(object sender, EventArgs e)
        {
            int n = elementListBox.SelectedIndex;
            if (n >= 0)
                elementListBox.Items.RemoveAt(n);
        }

        private void saveButton_Click(object sender, EventArgs e)
        {
            if (saveFileDialog1.ShowDialog() != DialogResult.OK)
                return;
            System.IO.StreamWriter sw = new System.IO.StreamWriter(saveFileDialog1.FileName);
            for (int i = 0; i < elementListBox.Items.Count; i++)
            {
                sw.Write(elementListBox.Items[i] + "\r");
            }
            sw.Close();
        }

        private void probeButton_Click(object sender, EventArgs e)
        {
            ProbeForm form = new ProbeForm();
            form.Tag = ((Button)sender).Tag;
            form.ParentForm1 = this;
            try
            {
                form.ShowDialog();
            }
            catch { }   // 検出完了後に何故が例外が発生するので、それの除去
        }

        private void logClearButton_Click(object sender, EventArgs e)
        {
            logTextBox.Clear();
        }

        // パワーオフ後2秒経過したら操作を許可する
        private void disableTimer_Tick(object sender, EventArgs e)
        {
            disableTimer.Enabled = false;
            Enabled = true;
        }

        // 無操作30秒で自動パワーオフ
        private void powerOffTimer_Tick(object sender, EventArgs e)
        {
            powerOffTimer.Enabled = false;
            sendCommand("$P");
            Enabled = false;
            disableTimer.Enabled = true;
        }

        private void keyTimer_Tick(object sender, EventArgs e)
        {
            if (Form.ActiveForm != this)
                return;
            string axis = "";
            double v = 0;
            if (System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.Left))     { axis = "X"; v = -0.05; }
            if (System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.Right))    { axis = "X"; v =  0.05; }
            if (System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.Down))     { axis = "Y"; v = -0.05; }
            if (System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.Up))       { axis = "Y"; v =  0.05; }
            if (System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.PageDown)) { axis = "Z"; v = -0.05; }
            if (System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.PageUp))   { axis = "Z"; v =  0.05; }
            if (v == 0)
                return;
            if (System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.LeftCtrl) ||
                System.Windows.Input.Keyboard.IsKeyDown(System.Windows.Input.Key.RightCtrl))
            {
                v *= 4;
            }
            if (serialPort1.IsOpen)
            {
                String str = String.Format("$J=G91G21{0}{1}F{2}", axis, v, F);   // インクリメンタル・メトリック・直線補完
                sendCommand(str);
            }

        }

        private void loadButton_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() != DialogResult.OK)
                return;
            elementListBox.Items.Clear();
            System.IO.StreamReader sr = new System.IO.StreamReader(openFileDialog1.FileName);
            while (!sr.EndOfStream)
            {
                String str = sr.ReadLine();
                elementListBox.Items.Add(str);
            }
            sr.Close();

            if (Form2.form2Obj == null)
            {
                Form2.Items = elementListBox.Items;
                Form2.form2Obj = new Form2();
            }
            Form2.form2Obj.Show();
            Form2.form2Obj.Draw();
        }

        private void stopButton_Click(object sender, EventArgs e)
        {
            // stop
            if (serialPort1.IsOpen)
                serialPort1.Write("!");
        }

        private void resetButton_Click(object sender, EventArgs e)
        {
            reset();
        }

        private void continueButton_Click(object sender, EventArgs e)
        {
            int n;
            if (!pausing)
                n = 0;
            else
                n = elementListBox.SelectedIndex + 1;

            if (elementListBox.Items.Count <= n)
            {
                elementListBox.SelectedIndex = -1;
                continueButton.Text = ">";
                return;
            }
            stateTextBox.Text = "Send";
            elementListBox.SelectedIndex = n;
            String str = (String)elementListBox.Items[n];
            sendCommand(str);
            playing = true;
            checkZcommand(str);
        }

        private void tabControl1_Selecting(object sender, TabControlCancelEventArgs e)
        {
            if (e.TabPageIndex == 0 && !serialPort1.IsOpen)
                e.Cancel = true;
        }

        private void SerialClose()
        {
            if (serialPort1.IsOpen)
            {
                timer1.Enabled = false;
                sendCommand("$P");      // モータ開放
                while (serialPort1.BytesToWrite > 0)
                {
                    System.Threading.Thread.Sleep(1);
                }
                System.Threading.Thread.Sleep(100);
                serialPort1.Close();
            }
        }

        private void connectButton_Click(object sender, EventArgs e)
        {
            if (!serialPort1.IsOpen)
            {
                // シリアルポートの初期化
                serialPort1.BaudRate = 115200;
                serialPort1.Parity = Parity.None;
                serialPort1.DataBits = 8;
                serialPort1.StopBits = StopBits.One;
                serialPort1.Handshake = Handshake.None;
                serialPort1.PortName = portComboBox.Text;
                // serialPort1.ReadTimeout = 100;
                try
                {
                    serialPort1.Open();
                }
                catch
                {
                    MessageBox.Show(serialPort1.PortName + "は使われています", "オープンエラー", MessageBoxButtons.OK);
                }
            }
            else
            {
                SerialClose();
            }
            if (serialPort1.IsOpen)
            {
                connectButton.Text = "切断";
                motorOffButton.Enabled = true;
                timer1.Enabled = true;
                tabControl1.SelectedIndex = 0;
                serialPort1.ReadExisting();         // ゴミデータをクリア
                reset();                            // リセット、直後にWCOパラメータが返ってくるからリセットする
                fTextBox.Text = F.ToString("F0");

                ini.setValue("System", "Port", serialPort1.PortName);
            }
            else
            {
                connectButton.Text = "接続";
                motorOffButton.Enabled = false;
                timer1.Enabled = false;
            }
        }

        // モータをオフする
        // オフした後は、モータドライバチップが安定するまで20秒間操作を禁止する
        private void motorOffButton_Click(object sender, EventArgs e)
        {
            sendCommand("$P");
            Enabled = false;
            disableTimer.Enabled = true;
        }

        private void checkZcommand(String cmd)
        {
            int n = cmd.IndexOf("Z");
            pausing = (n >= 0); // Zが含まれたらポーズ
            if (pausing)
            {
                continueButton.Text = "Z移動完了";
            }
            else
            {
                continueButton.Text = ">";
            }
        }

        delegate void SetTextCallback(string text);
        private void Response(string  text)
        {
            if (text == "")
                    return;
            if (this.logTextBox.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(Response);
                this.BeginInvoke(d, new object[] { text });
            }
            else
            {
                int n = text.Length;
                if (text[0] == '<' && text[n - 1] == '>')
                {   // ？に対する応答
                    String str = text.Substring(1, n - 2);   // 前後の<>を取る
                    Char sep1 = '|';
                    String[] token = str.Split(sep1);
                    if (token.Length >= 1)
                    {
                        stateTextBox.Text = token[0];
                        Color oldColor = stateTextBox.BackColor;
                        if (token[0] == "Idle")
                            stateTextBox.BackColor = Color.White;
                        else if (token[0] == "Run" || token[0] == "Jog")
                            stateTextBox.BackColor = Color.LightGreen;
                        else
                            stateTextBox.BackColor = Color.Red;
                        // Idle以外からIdle状態になればパワーオフタイマーをスタートさせる
                        if (oldColor != Color.White && stateTextBox.BackColor == Color.White)
                            powerOffTimer.Enabled = true;
                    }
                    for (int i = 0; i < token.Length; i++)
                    {
                        Char sep2 = ':';
                        String[] token2 = token[i].Split(sep2);
                        if (token2.Length >= 2 && (token2[0] == "WPos" || token2[0] == "MPos" || token2[0] == "WCO"))
                        {
                            Char sep3 = ',';
                            String[] token3 = token2[1].Split(sep3);
                            if (token3.Length >= 3)
                            {
                                if (token2[0] == "WCO")
                                {
                                    xWCO = System.Convert.ToDouble(token3[0]);
                                    yWCO = System.Convert.ToDouble(token3[1]);
                                    zWCO = System.Convert.ToDouble(token3[2]);
                                }
                                if (token2[0] == "MPos")
                                {
                                    xMPOS = System.Convert.ToDouble(token3[0]) - xOfs;
                                    yMPOS = System.Convert.ToDouble(token3[1]) - yOfs;
                                    zMPOS = System.Convert.ToDouble(token3[2]);
                                }
                                if (token2[0] == "WPos")
                                {
                                    xMPOS = System.Convert.ToDouble(token3[0]) + xWCO - xOfs;
                                    yMPOS = System.Convert.ToDouble(token3[1]) + yWCO - yOfs;
                                    zMPOS = System.Convert.ToDouble(token3[2]) + zWCO;
                                }
                            }
                        }
                    }
                    xTextBox.Text = (xMPOS - xWCO).ToString("F2");
                    yTextBox.Text = (yMPOS - yWCO).ToString("F2");
                    zTextBox.Text = (zMPOS - zWCO).ToString("F2");
                    if (Form2.form2Obj != null)
                    {
                        PointF p = new PointF((float)(xMPOS - xWCO), (float)(yMPOS - yWCO));
                        Form2.form2Obj.SetPoint(p);
                    }
                    if (!axisInitialized)
                    {
                        xCur = xMPOS - xWCO;
                        yCur = yMPOS - yWCO;
                        axisInitialized = true;
                    }
                    //                    zupTextBox.Text = (zUP - zWCO).ToString("N2");
                    fTextBox.Text = F.ToString("F0");
                }
                else
                {
                    Match m;
                    m = resetV.Match(text);
                    if (m.Groups.Count > 1)
                    {
                        // リセットに対する応答
                        // str = m.Groups["V"].Value;
                        sendCommand("$X");            // ロック解除
                        sendCommand("G90 G21");       // 絶対値指定 メトリック指定
                    }

                    string[] newLines = new string[logTextBox.Lines.Length];
                    Array.Copy(logTextBox.Lines, newLines, logTextBox.Lines.Length);
                    int i;
                    for(i = 0; i < newLines.Length; i++)
                    {
                        char ch = (char)0;
                        if (newLines[i].Length > 0)
                            ch = newLines[i][0];
                        if (ch == ' ')
                        {
                            newLines[i] = text + newLines[i];
                            break;
                        }
                    }
                    logTextBox.Lines = newLines;

                }
            }
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen)
                serialPort1.Write("?");         // ステータス取得
            if (commands.Length > 0 && stateTextBox.Text == "Idle")
            {
                string str = popCommand();
                serialPort1.Write(str + "\n");
                stateTextBox.Text = "Send";
                powerOffTimer.Enabled = false;
                return;
            }
            if (playing && !pausing && stateTextBox.Text == "Idle")
            {
                // 次の行を取得
                if (elementListBox.SelectedIndex + 1 >= elementListBox.Items.Count)
                {
                    // 最後まで来たので再生終了
                    playing = false;
                    elementListBox.SelectedIndex = -1;
                    return;
                }
                elementListBox.SelectedIndex = elementListBox.SelectedIndex + 1;
                String str = (String)elementListBox.Items[elementListBox.SelectedIndex];
                sendCommand(str);
                stateTextBox.Text = "Send";
                checkZcommand(str);
            }
        }

        private void serialPort1_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {
            String str = serialPort1.ReadLine();            // \nまで読む
            if (str[str.Length - 1] == '\r')
                str = str.Substring(0, str.Length - 1);     // \rを取る
            Response(str);
        }

        private void pushCommand(string cmd)
        {
            string[] newCommands = new string[commands.Length + 1];
            commands.CopyTo(newCommands, 0);
            newCommands[commands.Length] = cmd;
            commands = newCommands;
        }


        private string popCommand()
        {
            string ret = "";
            if (commands.Length > 0) {
                ret = commands[0];
                string[] newCommands = new string[commands.Length - 1];
                for(int i = 0; i < commands.Length - 1; i++)
                    newCommands[i] = commands[i + 1];
                commands = newCommands;
            }
            return ret;
        }

        // バックラッシュの調整
        private void getOfs(bool xPlus1, bool yPlus1, double x, double y, double f)
        {
            double xOfs1, yOfs1;
            if (xPlus1)
                xOfs1 = 0;
            else
                xOfs1 = -xBacklash;
            if (yPlus1)
                yOfs1 = 0;
            else
                yOfs1 = -yBacklash;
            if ((xPlus ^ xPlus1) || (yPlus ^ yPlus1))
            {
                double x1 = xCur + xOfs1;
                double y1 = yCur + yOfs1;
                string str = "G01X" + x1.ToString("N2") + "Y" + y1.ToString("N2") + "F" + f.ToString("N0");
                logTextBox.AppendText(" " + str + "\n");
                if (commands.Length == 0)
                    serialPort1.Write(str + "\n"); // コマンドバッファに入れるとバックラッシュ調整時にがたつき音がするため連続データ送付
                else
                    pushCommand(str);
                stateTextBox.Text = "Send";
            }
            xOfs = xOfs1;
            yOfs = yOfs1;
            xPlus = xPlus1;
            yPlus = yPlus1;
        }

        public string GetState()
        {
            return stateTextBox.Text;
        }

        public void sendCommand(string cmd)
        {
            powerOffTimer.Enabled = false;

            Match m;
            int mode = 0;
            if (jogR.IsMatch(cmd))
                mode = 1;
            else if (jogA.IsMatch(cmd))
                mode = 2;
            else if (line.IsMatch(cmd))
                mode = 11;
            else if (cw.IsMatch(cmd))
                mode = 12;
            else if (ccw.IsMatch(cmd))
                mode = 13;
            if (mode == 0)
            {
                if (cmd != "")
                {
                    logTextBox.AppendText(" " + cmd + "\r\n");
                    serialPort1.Write(cmd + "\n");
                    stateTextBox.Text = "Send";
                }
                return;
            }

            double x0, y0;
            double x = xCur;
            bool xSet = false;
            m = valX.Match(cmd);
            if (m.Groups.Count > 1)
            {
                x = System.Convert.ToDouble(m.Groups["V"].Value);
                xSet = true;
            }

            double y = yCur;
            bool ySet = false;
            m = valY.Match(cmd);
            if (m.Groups.Count > 1)
            {
                y = System.Convert.ToDouble(m.Groups["V"].Value);
                ySet = true;
            }

            double i = 0;
            m = valI.Match(cmd);
            if (m.Groups.Count > 1)
                i = System.Convert.ToDouble(m.Groups["V"].Value);

            double j = 0;
            m = valJ.Match(cmd);
            if (m.Groups.Count > 1)
                j = System.Convert.ToDouble(m.Groups["V"].Value);

            double f = F;
            m = valF.Match(cmd);
            if (m.Groups.Count > 1)
                f = System.Convert.ToDouble(m.Groups["V"].Value);

            string str;
            bool xPlus1, yPlus1;
            double sRad, eRad, rad;

            // jog相対値
            if (mode == 1)
            {
                if (!xSet)
                    x = 0;
                if (!ySet)
                    y = 0;
                x += xCur;
                y += yCur;
                xPlus1 = (x >= xCur);
                yPlus1 = (y >= yCur);
                getOfs(xPlus1, yPlus1, xCur, yCur, f);
                xCur = x;
                yCur = y;
                str = "G01X" + (x + xOfs).ToString("N2") + "Y" + (y + yOfs).ToString("N2") + "F100";
                logTextBox.AppendText(" " + str + "\n");
                pushCommand(str);
            }
            // jog絶対値
            if (mode == 2)
            {
                xPlus1 = (x >= xCur);
                yPlus1 = (y >= yCur);
                getOfs(xPlus1, yPlus1, x, y, f);
                xCur = x;
                yCur = y;
                str = "G01X" + (x + xOfs).ToString("N2") + "Y" + (y + yOfs).ToString("N2") + "F100";
                logTextBox.AppendText(" " + str + "\n");
                pushCommand(str);
            }
            // 直線
            if (mode == 11)
            {
                xPlus1 = (x >= xCur);
                yPlus1 = (y >= yCur);
                getOfs(xPlus1, yPlus1, x, y, f);
                xCur = x;
                yCur = y;
                str = "G01X" + (x + xOfs).ToString("N2") + "Y" + (y + yOfs).ToString("N2") + "F" + f.ToString("N0");
                logTextBox.AppendText(" " + str + "\n");
                pushCommand(str);
            }
            // CW円弧
            if (mode == 12)
            {
                sRad = Math.Atan2(-j, -i);
                eRad = Math.Atan2(y - yCur - j, x - xCur - i);
                double r = Math.Sqrt(i * i + j * j);
                double cx = xCur + i;
                double cy = yCur + j;
                if (sRad <= eRad)
                    sRad += Math.PI * 2;
                if (sRad >= Math.PI)
                {
                    sRad -= Math.PI * 2;
                    eRad -= Math.PI * 2;
                }
                while (eRad < sRad)
                {
                    if (sRad - eRad < 0.001)
                        break;
                    if (sRad <= -Math.PI)
                    {
                        sRad += Math.PI * 2;
                        eRad += Math.PI * 2;
                    }
                    // 現在位置
                    xCur = cx + r * Math.Cos(sRad);
                    yCur = cy + r * Math.Sin(sRad);
                    if (Math.PI >= sRad && sRad > Math.PI / 2)
                        rad = Math.Max(eRad, Math.PI / 2);
                    else
                    if (Math.PI / 2 >= sRad && sRad > 0)
                        rad = Math.Max(eRad, 0);
                    else
                    if (0 >= sRad && sRad > -Math.PI / 2)
                        rad = Math.Max(eRad, -Math.PI / 2);
                    else
                        rad = Math.Max(eRad, -Math.PI);
                    x0 = cx + r * Math.Cos(rad);
                    y0 = cy + r * Math.Sin(rad);
                    getOfs(x0 >= xCur, y0 >= yCur, x0, y0, f);
                    str = "G02X" + (cx + r * Math.Cos(rad) + xOfs).ToString("N2") + "Y" + (cy + r * Math.Sin(rad) + yOfs).ToString("N2") +
                        "I" + (cx - xCur).ToString("N2") + "J" + (cy - yCur).ToString("N2") + "F" + f.ToString("N0");
                    logTextBox.AppendText(" " + str + "\n");
                    pushCommand(str);
                    sRad = rad;
                }
                xCur = cx + r * Math.Cos(eRad);
                yCur = cy + r * Math.Sin(eRad);
            }
            // CCW円弧
            if (mode == 13)
            {
                sRad = Math.Atan2(-j, -i);
                eRad = Math.Atan2(y - yCur - j, x - xCur - i);
                double r = Math.Sqrt(i * i + j * j);
                double cx = xCur + i;
                double cy = yCur + j;
                if (eRad <= sRad)
                    eRad += Math.PI * 2;
                while (eRad > sRad)
                {
                    if (eRad - sRad < 0.001)
                        break;
                    if (sRad >= Math.PI)
                    {
                        sRad -= Math.PI * 2;
                        eRad -= Math.PI * 2;
                    }
                    // 現在位置
                    xCur = cx + r * Math.Cos(sRad);
                    yCur = cy + r * Math.Sin(sRad);
                    if (Math.PI / 2 <= sRad && sRad < Math.PI)
                        rad = Math.Min(eRad, Math.PI);
                    else
                    if (0 <= sRad && sRad < Math.PI / 2)
                        rad = Math.Min(eRad, Math.PI / 2);
                    else
                    if (-Math.PI / 2 <= sRad && sRad < 0)
                        rad = Math.Min(eRad, 0);
                    else
                        rad = Math.Min(eRad, -Math.PI / 2);
                    x0 = cx + r * Math.Cos(rad);
                    y0 = cy + r * Math.Sin(rad);
                    getOfs(x0 >= xCur, y0 >= yCur, x0, y0, f);
                    str = "G03X" + (cx + r * Math.Cos(rad) + xOfs).ToString("N2") + "Y" + (cy + r * Math.Sin(rad) + yOfs).ToString("N2") +
                        "I" + (cx - xCur).ToString("N2") + "J" + (cy - yCur).ToString("N2") + "F" + f.ToString("N0");
                    logTextBox.AppendText(" " + str + "\n");
                    pushCommand(str);
                    sRad = rad;
                }
                xCur = cx + r * Math.Cos(eRad);
                yCur = cy + r * Math.Sin(eRad);
            }
            if (commands.Length > 0) { 
                serialPort1.Write(" " + popCommand() + "\n");
                stateTextBox.Text = "Send";
            }
        }

    }
}
