﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Text.RegularExpressions;

namespace NCC
{
    public partial class Form2 : Form
    {
        public Form2()
        {
            InitializeComponent();
        }
        public static Form2 form2Obj;
        public static ListBox.ObjectCollection Items;
        private float x0, y0, rr;
        private PointF cur;

        private void Form2_FormClosed(object sender, FormClosedEventArgs e)
        {
            form2Obj = null;
        }

        private void Form2_Load(object sender, EventArgs e)
        {
            form2Obj = this;
            pictureBox1.Width = ClientSize.Width;
            pictureBox1.Height = ClientSize.Height;
            Width = 800;
            Height = 600;
            cur.X = 0;
            cur.Y = 0;
        }

        private void Form2_Resize(object sender, EventArgs e)
        {
            Draw();
        }

        private void Form2_Paint(object sender, PaintEventArgs e)
        {
            Draw();
        }

        public void SetPoint(PointF pt)
        {
            cur = pt;
            Draw();
        }

        public void Draw()
        {
            BufferedGraphicsContext bgc = BufferedGraphicsManager.Current;
            BufferedGraphics bg = bgc.Allocate(pictureBox1.CreateGraphics(), pictureBox1.DisplayRectangle);
            Graphics g = bg.Graphics;

//            Graphics g = pictureBox1.CreateGraphics();// e.Graphics;
            g.Clear(Color.White);

//            g.DrawString("This is a diagonal line drawn on the control",
//                new Font("Arial", 10), System.Drawing.Brushes.Blue, new Point(30, 30));

            Regex valX, valY, valI, valJ;
            valX = new Regex(@"X(?<V>-?\d+(\.\d*)?)", RegexOptions.IgnoreCase | RegexOptions.Singleline);
            valY = new Regex(@"Y(?<V>-?\d+(\.\d*)?)", RegexOptions.IgnoreCase | RegexOptions.Singleline);
            valI = new Regex(@"I(?<V>-?\d+(\.\d*)?)", RegexOptions.IgnoreCase | RegexOptions.Singleline);
            valJ = new Regex(@"J(?<V>-?\d+(\.\d*)?)", RegexOptions.IgnoreCase | RegexOptions.Singleline);

            float x1, y1, x2, y2, cx, cy;
            float minX, minY, maxX, maxY;
            Match m;
            x1 = y1 = 0;
            minX = minY = -9999;
            maxX = maxY = -9999;
            //            minX = minY = 0;
            //            maxX = maxY = 0;
            //            maxX = 70;
            //            maxY = 70;
            //            minX = -40;
            //            minY = -40;
            for (int i = 0; i < Items.Count; i++)
            {
                m = valX.Match((string)Items[i]);
                if (m.Groups.Count > 1)
                {
                    x2 = (float)System.Convert.ToDouble(m.Groups["V"].Value);
                    if (minX < -999) minX = maxX = x2;
                    if (minX > x2) minX = x2;
                    if (maxX < x2) maxX = x2;
                }
                m = valY.Match((string)Items[i]);
                if (m.Groups.Count > 1)
                {
                    y2 = (float)System.Convert.ToDouble(m.Groups["V"].Value);
                    if (minY < -999) minY = maxY = y2;
                    if (minY > y2) minY = y2;
                    if (maxY < y2) maxY = y2;
                }
            }
            minX -= 5;
            minY -= 5;
            maxX += 5;
            maxY += 5;
            float rx = pictureBox1.Width / (maxX - minX);
            float ry = pictureBox1.Height / (maxY - minY);
            rr = Math.Min(rx, ry);
            x0 = minX - (pictureBox1.Width / rr - (maxX - minX)) / 2;
            y0 = minY - (pictureBox1.Height / rr - (maxY - minY)) / 2;
            float yy = pictureBox1.Height;

            // 方眼の描画
            System.Drawing.Pen pen;
            for (int x = -100; x <= 200; x += 5)
            {
                if (x % 100 == 0)
                    pen = Pens.Black;
                else if (x % 10 == 0)
                    pen = Pens.DarkGray;
                else
                    pen = Pens.LightGray;
                g.DrawLine(pen, (x - x0) * rr, 0, (x - x0) * rr, pictureBox1.Height);
            }
            for (int y = -100; y <= 200; y += 5)
            {
                if (y % 100 == 0)
                    pen = Pens.Black;
                else if (y % 10 == 0)
                    pen = Pens.DarkGray;
                else
                    pen = Pens.LightGray;
                g.DrawLine(pen, 0, yy - (y - y0) * rr, pictureBox1.Width, yy - (y - y0) * rr);
            }

            // 作図
            bool xSet, ySet;
            for (int i = 0; i < Items.Count; i++)
            {
                string str = (string)Items[i];
                m = valX.Match(str);
                if (m.Groups.Count > 1)
                {
                    x2 = (float)System.Convert.ToDouble(m.Groups["V"].Value);
                    xSet = true;
                }
                else
                {
                    xSet = false;
                    x2 = x1;
                }
                m = valY.Match(str);
                if (m.Groups.Count > 1)
                {
                    y2 = (float)System.Convert.ToDouble(m.Groups["V"].Value);
                    ySet = true;
                }
                else
                {
                    ySet = false;
                    y2 = y1;
                }
                if (i > 0 && (xSet || ySet))
                {
                    int code = 0;
                    for (int j = 0; j < str.Length; j++)
                    {
                        if (str[j] == 'G' || str[j] == 'g')
                        {
                            for (j++; j < str.Length; j++)
                            {
                                if ('0' <= str[j] && str[j] <= '9')
                                    code = code * 10 + str[j] - '0';
                                else
                                    break;
                            }
                            break;
                        }
                    }
                    if (code == 0 || code == 1)
                        g.DrawLine(System.Drawing.Pens.Red, (x1 - x0) * rr, yy - (y1 - y0) * rr, (x2 - x0) * rr, yy - (y2 - y0) * rr);
                    else if (code == 2 || code == 3)
                    {
                        m = valI.Match(str);
                        if (m.Groups.Count > 1)
                            cx = x1 + (float)System.Convert.ToDouble(m.Groups["V"].Value);
                        else
                            cx = x1;
                        m = valJ.Match(str);
                        if (m.Groups.Count > 1)
                            cy = y1 + (float)System.Convert.ToDouble(m.Groups["V"].Value);
                        else
                            cy = y1;
                        float r = (float)Math.Sqrt((x1 - cx) * (x1 - cx) + (y1 - cy) * (y1 - cy));
                        float d1 = (float)(Math.Atan2(y1 - cy, x1 - cx) * 180 / Math.PI);
                        float d2 = (float)(Math.Atan2(y2 - cy, x2 - cx) * 180 / Math.PI);
                        float xxx = (x1 - x0) * rr;
                        float yyy = yy -(y1 - y0) * rr;
                        g.DrawLine(System.Drawing.Pens.Red, xxx - 2, yyy - 2, xxx + 2, yyy + 2);
                        g.DrawLine(System.Drawing.Pens.Red, xxx - 2, yyy + 2, xxx + 2, yyy - 2);
                        xxx = (cx - x0) * rr;
                        yyy = yy - (cy - y0) * rr;
                        g.DrawLine(System.Drawing.Pens.Red, xxx - 2, yyy, xxx + 2, yyy);
                        g.DrawLine(System.Drawing.Pens.Red, xxx, yyy + 2, xxx, yyy - 2);
                        if (code == 2)
                        {
                            if (d2 >= d1)
                                d2 -= 360;
                        } else
                        {
                            if (d1 >= d2)
                                d1 -= 360;
                        }
                        g.DrawArc(System.Drawing.Pens.Red, (cx - r - x0) * rr, yy - (cy + r - y0) * rr, r * 2 * rr, r * 2 * rr,
                            -d1, d1 - d2);
                    }
                }
                if (xSet)
                    x1 = x2;
                if (ySet)
                    y1 = y2;
            }

            float fx, fy;
            fx = (cur.X - x0) * rr;
            fy = yy - (cur.Y - y0) * rr;
            g.DrawLine(System.Drawing.Pens.Blue, fx - 2, fy - 2, fx + 2, fy - 2);
            g.DrawLine(System.Drawing.Pens.Blue, fx + 2, fy - 2, fx + 2, fy + 2);
            g.DrawLine(System.Drawing.Pens.Blue, fx + 2, fy + 2, fx - 2, fy + 2);
            g.DrawLine(System.Drawing.Pens.Blue, fx - 2, fy + 2, fx - 2, fy - 2);

            bg.Render();
        }

    }
}
